/*
    GitHub URL: https://github.com/gucastiliao/video-popup-js .// Modifyto API by :ratchapon
*/

(function ($) {
	$.fn.videoPopup = function (options) {

		var elm = document.getElementById("iframe-api");

		if (elm = "undefined") {
			//console.log('add script');	

			var tag = document.createElement('script');
			tag.id = 'iframe-api';
			tag.src = 'https://www.youtube.com/iframe_api';
			var firstScriptTag = document.getElementsByTagName('script')[0];
			firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);

		}

		var settings = $.extend({
			autoplay: false,
			showControls: true,
			controlsColor: null,
			loopVideo: false,
			showVideoInformations: true,
			width: null,
			customOptions: {}
		}, options);

		$(this).css('cursor', 'pointer');
		$(this).on('click', function (event) {
			var videoUrl = $(this).attr("video-url");
			var vdoID = videoUrl.split("=")[1];
			//console.log('video Clicked '+ vdoID);

			var player;
			var videoTitle;
			var videoPlay = {
				ten: false,
				twentyFive: false,
				fifty: false,
				seventyFive: false
			};
			var videoTimer;


			$("body").append(mountIframe());



			$('.videopopupjs__content').css('max-width', 700);
			if (settings.width) {
				$('.videopopupjs__content').css('max-width', settings.width);
			}

			if ($('.videopopupjs').hasClass('videopopupjs--animation')) {
				setTimeout(function () {
					$('.videopopupjs').removeClass("videopopupjs--animation");
				}, 200);
			}

			$(".videopopupjs, .videopopupjs__close").click(function () {
				$(".videopopupjs").addClass("videopopupjs--hide").delay(515).queue(function () {
					$(this).remove();
				});
			});



			player = new YT.Player('spotlight-video', {
				videoId: vdoID,
				events: {
					'onReady': onPlayerReady,
					'onStateChange': onPlayerStateChange
				}
			});

			setTimeout(function () {
				player.playVideo();
			}, 500);

			function onPlayerReady(event) {
				videoTitle = player.getVideoData().title;
				//console.log(videoTitle);
				event.target.playVideo();
			}

			function onPlayerStateChange(event) {
				switch (event.data) {
					case 0: // ended
						clearInterval(videoTimer);
						setTimeout(function () {
							$(".videopopupjs").remove();
						}, 100);
						break;
					case 1: // playing
						var playerTotalTime = player.getDuration();
						videoTimer = setInterval(function () {
							var playerCurrentTime = player.getCurrentTime();
							var playerTimeDifference = (playerCurrentTime / playerTotalTime) * 100;
							var playerPercentage = Math.round(playerTimeDifference, 2);

							if ((playerPercentage >= 10) && (!videoPlay.ten)) {
								videoPlay.ten = true;
							}
							if ((playerPercentage >= 25) && (!videoPlay.twentyFive)) {
								videoPlay.twentyFive = true;
							}
							if ((playerPercentage >= 50) && (!videoPlay.fifty)) {
								videoPlay.fifty = true;
							}
							if ((playerPercentage >= 75) && (!videoPlay.seventyFive)) {
								videoPlay.seventyFive = true;
							}
						}, 1000);
						break;
				}
			}

			function mountIframe() {
				var iframeElement = '<div id="spotlight-video">xxxxxx</div>';
				return '<div class="videopopupjs videopopupjs--animation">' +
					'<div class="videopopupjs__content">' +
					'<span class="videopopupjs__close"></span>' +
					iframeElement +
					'</div>' +
					'</div>';
			}
			event.preventDefault();
		});



		return this;
	};
}(jQuery));
